<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_patient".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPatient".
 *
 * Columns in table "provider_patient" available as properties of the model,
 * followed by relations of table "provider_patient" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $patient_id
 * @property integer $primary_provider
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Patient $patient
 * @property Provider $provider
 */
abstract class BaseProviderPatient extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_patient';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPatient|ProviderPatients', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('provider_id, patient_id', 'required'),
            array('provider_id, patient_id, primary_provider', 'numerical', 'integerOnly' => true),
            array('date_added, date_updated', 'safe'),
            array('primary_provider, date_added, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, patient_id, primary_provider, date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'patient' => array(self::BELONGS_TO, 'Patient', 'patient_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'patient_id' => null,
            'primary_provider' => Yii::t('app', 'Primary Provider'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'patient' => null,
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('primary_provider', $this->primary_provider);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
